Bug 1042824 - (CVE-2017-9407) VUL-2: CVE-2017-9407: ImageMagick: Memory leak in the ReadPALMImage function
(CVE-2017-9407)
VUL-2: CVE-2017-9407: ImageMagick: Memory leak in the ReadPALMImage function
Status: RESOLVED FIXED
Classification: Novell Products
Product: SUSE Security Incidents
Classification: Novell Products
Component: Incidents
unspecified
Other Other
: P3 - Medium : Minor
: ---
Assigned To: Security Team bot
Security Team bot
https://smash.suse.de/issue/186224/
CVSSv3:RedHat:CVE-2017-9407:3.3:(AV:L...
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2017-06-06 07:20 UTC by Victor Pereira
Modified: 2018-03-06 23:46 UTC (History)
3 users (show)

See Also:
Found By: Security Response Team
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments
memory-leak-in-ReadPALMImage-20.palm (24.02 KB, application/octet-stream)
2017-08-25 13:40 UTC, Marcus Meissner
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Victor Pereira 2017-06-06 07:20:35 UTC
rh#1458813

In ImageMagick 7.0.5-5, the ReadPALMImage function in palm.c allows attackers to
cause a denial of service (memory leak) via a crafted file.

References:
https://bugzilla.redhat.com/show_bug.cgi?id=1458813
http://web.nvd.nist.gov/view/vuln/detail?vulnId=CVE-2017-9407
http://people.canonical.com/~ubuntu-security/cve/2017/CVE-2017-9407.html
http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-9407
https://github.com/ImageMagick/ImageMagick/issues/459
Comment 1 Marcus Meissner 2017-08-25 13:40:55 UTC
Created attachment 738317 [details]
memory-leak-in-ReadPALMImage-20.palm

QA REPRODUCER:

valgrind --leak-check=full identify memory-leak-in-ReadPALMImage-20.palm
Comment 2 Marcus Meissner 2017-09-27 13:14:50 UTC
leaks 1 image row, consider minor.
Comment 3 Petr Gajdos 2018-01-31 12:49:03 UTC
BEFORE

12/ImageMagick

$ valgrind -q --leak-check=full identify memory-leak-in-ReadPALMImage-20.palm
identify: corrupt image `memory-leak-in-ReadPALMImage-20.palm' @ error/palm.c/ReadPALMImage/476.
==24128== 256 bytes in 1 blocks are definitely lost in loss record 10 of 10
==24128==    at 0x4C29110: malloc (in /usr/lib64/valgrind/vgpreload_memcheck-amd64-linux.so)
==24128==    by 0x8419CB9: ???
==24128==    by 0x4EBFE1A: ReadImage (constitute.c:601)
==24128==    by 0x4FD1638: ReadStream (stream.c:974)
==24128==    by 0x4EBF960: PingImage (constitute.c:278)
==24128==    by 0x4EBFB9A: PingImages (constitute.c:373)
==24128==    by 0x535850B: IdentifyImageCommand (identify.c:322)
==24128==    by 0x5385C52: MagickCommandGenesis (mogrify.c:166)
==24128==    by 0x400891: IdentifyMain (identify.c:80)
==24128==    by 0x400891: main (identify.c:93)
==24128== 
$

11/ImageMagick

$ valgrind -q identify memory-leak-in-ReadPALMImage-20.palm
identify: Corrupt image `memory-leak-in-ReadPALMImage-20.palm'.
$

11/GraphicsMagick

$ valgrind -q --leak-check=full gm identify memory-leak-in-ReadPALMImage-20.palm
gm identify: Corrupt image (memory-leak-in-ReadPALMImage-20.palm).
==24154== 
==24154== 256 bytes in 1 blocks are definitely lost in loss record 2 of 2
==24154==    at 0x4C256AE: malloc (in /usr/lib64/valgrind/amd64-linux/vgpreload_memcheck.so)
==24154==    by 0x8028554: ???
==24154==    by 0x4EA01CC: ReadImage (constitute.c:6000)
==24154==    by 0x4EFC39D: ReadStream (pixel_cache.c:3653)
==24154==    by 0x4EA0FA8: PingImage (constitute.c:5770)
==24154==    by 0x4E86A87: IdentifyImageCommand (command.c:7204)
==24154==    by 0x4E73683: MagickCommand (command.c:7657)
==24154==    by 0x4E737FE: GMCommand (command.c:15277)
==24154==    by 0x76E2585: (below main) (in /lib64/libc-2.9.so)
$

42.3/GraphicsMagick

$ valgrind -q gm identify memory-leak-in-ReadPALMImage-20.palm
gm identify: Improper image header (memory-leak-in-ReadPALMImage-20.palm).
gm identify: Request did not return an image.
$

PATCH

https://github.com/ImageMagick/ImageMagick/commit/7851278ed92bcdef72132ceadee9256c9d98acf1

42.3,HG/GraphicsMagick: fixed by ThrowPALMReaderException()

AFTER

12/ImageMagick

$ valgrind -q --leak-check=full identify memory-leak-in-ReadPALMImage-20.palm
identify: corrupt image `memory-leak-in-ReadPALMImage-20.palm' @ error/palm.c/ReadPALMImage/483.
$

11/ImageMagick

$ valgrind -q --leak-check=full identify memory-leak-in-ReadPALMImage-20.palm
identify: corrupt image `memory-leak-in-ReadPALMImage-20.palm' @ error/palm.c/ReadPALMImage/483.
$

11/GraphicsMagick

$ valgrind -q --leak-check=full gm identify memory-leak-in-ReadPALMImage-20.palm
gm identify: Memory allocation failed (memory-leak-in-ReadPALMImage-20.palm).
$
Comment 4 Petr Gajdos 2018-01-31 12:49:32 UTC
Will submit for: 12/ImageMagick, 11/ImageMagick and 11/GraphicsMagick
Comment 5 Petr Gajdos 2018-02-02 09:31:01 UTC
I believe all fixed.
Comment 9 Swamp Workflow Management 2018-02-20 14:08:04 UTC
SUSE-SU-2018:0486-1: An update that fixes 24 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1042824,1048110,1049374,1049375,1050048,1050617,1050669,1052207,1052248,1052251,1052254,1052472,1052688,1052711,1052747,1052750,1052761,1055069,1055229,1058009,1074119,1076182,1078433
CVE References: CVE-2017-11166,CVE-2017-11448,CVE-2017-11450,CVE-2017-11537,CVE-2017-11637,CVE-2017-11638,CVE-2017-11642,CVE-2017-12418,CVE-2017-12427,CVE-2017-12429,CVE-2017-12432,CVE-2017-12566,CVE-2017-12654,CVE-2017-12664,CVE-2017-12665,CVE-2017-12668,CVE-2017-12674,CVE-2017-13058,CVE-2017-13131,CVE-2017-14224,CVE-2017-17885,CVE-2017-18028,CVE-2017-9407,CVE-2018-6405
Sources used:
SUSE Linux Enterprise Software Development Kit 11-SP4 (src):    ImageMagick-6.4.3.6-7.78.34.1
SUSE Linux Enterprise Server 11-SP4 (src):    ImageMagick-6.4.3.6-7.78.34.1
SUSE Linux Enterprise Debuginfo 11-SP4 (src):    ImageMagick-6.4.3.6-7.78.34.1
Comment 10 Swamp Workflow Management 2018-02-22 14:08:27 UTC
SUSE-SU-2018:0524-1: An update that fixes 20 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1042824,1047900,1049374,1049375,1050617,1050669,1052248,1052251,1052254,1052472,1052688,1055069,1055229,1058009,1072934,1073081,1074307,1076182,1078433
CVE References: CVE-2017-11140,CVE-2017-11448,CVE-2017-11450,CVE-2017-11637,CVE-2017-11638,CVE-2017-11642,CVE-2017-12427,CVE-2017-12429,CVE-2017-12432,CVE-2017-12566,CVE-2017-12668,CVE-2017-13058,CVE-2017-13131,CVE-2017-14224,CVE-2017-17502,CVE-2017-17503,CVE-2017-17912,CVE-2017-18028,CVE-2017-9407,CVE-2018-6405
Sources used:
SUSE Studio Onsite 1.3 (src):    GraphicsMagick-1.2.5-4.78.38.1
SUSE Linux Enterprise Software Development Kit 11-SP4 (src):    GraphicsMagick-1.2.5-4.78.38.1
SUSE Linux Enterprise Debuginfo 11-SP4 (src):    GraphicsMagick-1.2.5-4.78.38.1
Comment 11 Swamp Workflow Management 2018-03-01 20:14:43 UTC
SUSE-SU-2018:0581-1: An update that fixes 35 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1042824,1042911,1048110,1048272,1049374,1049375,1050048,1050119,1050122,1050126,1050132,1050617,1052207,1052248,1052251,1052254,1052472,1052688,1052711,1052747,1052750,1052754,1052761,1055069,1055229,1056768,1057163,1058009,1072898,1074119,1074170,1075821,1076182,1078433
CVE References: CVE-2017-11166,CVE-2017-11170,CVE-2017-11448,CVE-2017-11450,CVE-2017-11528,CVE-2017-11530,CVE-2017-11531,CVE-2017-11533,CVE-2017-11537,CVE-2017-11638,CVE-2017-11642,CVE-2017-12418,CVE-2017-12427,CVE-2017-12429,CVE-2017-12432,CVE-2017-12566,CVE-2017-12654,CVE-2017-12663,CVE-2017-12664,CVE-2017-12665,CVE-2017-12668,CVE-2017-12674,CVE-2017-13058,CVE-2017-13131,CVE-2017-14060,CVE-2017-14139,CVE-2017-14224,CVE-2017-17682,CVE-2017-17885,CVE-2017-17934,CVE-2017-18028,CVE-2017-9405,CVE-2017-9407,CVE-2018-5357,CVE-2018-6405
Sources used:
SUSE Linux Enterprise Workstation Extension 12-SP3 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Workstation Extension 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Software Development Kit 12-SP3 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Software Development Kit 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Server for Raspberry Pi 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Server 12-SP3 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Server 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Desktop 12-SP3 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Desktop 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
Comment 12 Andreas Stieger 2018-03-06 19:44:25 UTC
Releasing for Leap, showing as done otherwise
Comment 13 Swamp Workflow Management 2018-03-06 23:13:36 UTC
openSUSE-SU-2018:0621-1: An update that fixes 35 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1042824,1042911,1048110,1048272,1049374,1049375,1050048,1050119,1050122,1050126,1050132,1050617,1052207,1052248,1052251,1052254,1052472,1052688,1052711,1052747,1052750,1052754,1052761,1055069,1055229,1056768,1057163,1058009,1072898,1074119,1074170,1075821,1076182,1078433
CVE References: CVE-2017-11166,CVE-2017-11170,CVE-2017-11448,CVE-2017-11450,CVE-2017-11528,CVE-2017-11530,CVE-2017-11531,CVE-2017-11533,CVE-2017-11537,CVE-2017-11638,CVE-2017-11642,CVE-2017-12418,CVE-2017-12427,CVE-2017-12429,CVE-2017-12432,CVE-2017-12566,CVE-2017-12654,CVE-2017-12663,CVE-2017-12664,CVE-2017-12665,CVE-2017-12668,CVE-2017-12674,CVE-2017-13058,CVE-2017-13131,CVE-2017-14060,CVE-2017-14139,CVE-2017-14224,CVE-2017-17682,CVE-2017-17885,CVE-2017-17934,CVE-2017-18028,CVE-2017-9405,CVE-2017-9407,CVE-2018-5357,CVE-2018-6405
Sources used:
openSUSE Leap 42.3 (src):    ImageMagick-6.8.8.1-55.1